// Code generated by Prisma (prisma@1.34.12). DO NOT EDIT.
// Please don't change this file manually but run `prisma generate` to update it.
// For more information, please read the docs: https://www.prisma.io/docs/prisma-client/

import { DocumentNode } from "graphql";
import {
  makePrismaClientClass,
  BaseClientOptions,
  Model
} from "prisma-client-lib";
import { typeDefs } from "./prisma-schema";

export type AtLeastOne<T, U = { [K in keyof T]: Pick<T, K> }> = Partial<T> &
  U[keyof U];

export type Maybe<T> = T | undefined | null;

export interface Exists {
  availability: (where?: AvailabilityWhereInput) => Promise<boolean>;
  careType: (where?: CareTypeWhereInput) => Promise<boolean>;
  unavailability: (where?: UnavailabilityWhereInput) => Promise<boolean>;
}

export interface Node {}

export type FragmentableArray<T> = Promise<Array<T>> & Fragmentable;

export interface Fragmentable {
  $fragment<T>(fragment: string | DocumentNode): Promise<T>;
}

export interface Prisma {
  $exists: Exists;
  $graphql: <T = any>(
    query: string,
    variables?: { [key: string]: any }
  ) => Promise<T>;

  /**
   * Queries
   */

  availability: (
    where: AvailabilityWhereUniqueInput
  ) => AvailabilityNullablePromise;
  availabilities: (args?: {
    where?: AvailabilityWhereInput;
    orderBy?: AvailabilityOrderByInput;
    skip?: Int;
    after?: String;
    before?: String;
    first?: Int;
    last?: Int;
  }) => FragmentableArray<Availability>;
  availabilitiesConnection: (args?: {
    where?: AvailabilityWhereInput;
    orderBy?: AvailabilityOrderByInput;
    skip?: Int;
    after?: String;
    before?: String;
    first?: Int;
    last?: Int;
  }) => AvailabilityConnectionPromise;
  careType: (where: CareTypeWhereUniqueInput) => CareTypeNullablePromise;
  careTypes: (args?: {
    where?: CareTypeWhereInput;
    orderBy?: CareTypeOrderByInput;
    skip?: Int;
    after?: String;
    before?: String;
    first?: Int;
    last?: Int;
  }) => FragmentableArray<CareType>;
  careTypesConnection: (args?: {
    where?: CareTypeWhereInput;
    orderBy?: CareTypeOrderByInput;
    skip?: Int;
    after?: String;
    before?: String;
    first?: Int;
    last?: Int;
  }) => CareTypeConnectionPromise;
  unavailability: (
    where: UnavailabilityWhereUniqueInput
  ) => UnavailabilityNullablePromise;
  unavailabilities: (args?: {
    where?: UnavailabilityWhereInput;
    orderBy?: UnavailabilityOrderByInput;
    skip?: Int;
    after?: String;
    before?: String;
    first?: Int;
    last?: Int;
  }) => FragmentableArray<Unavailability>;
  unavailabilitiesConnection: (args?: {
    where?: UnavailabilityWhereInput;
    orderBy?: UnavailabilityOrderByInput;
    skip?: Int;
    after?: String;
    before?: String;
    first?: Int;
    last?: Int;
  }) => UnavailabilityConnectionPromise;
  node: (args: { id: ID_Output }) => Node;

  /**
   * Mutations
   */

  createAvailability: (data: AvailabilityCreateInput) => AvailabilityPromise;
  updateAvailability: (args: {
    data: AvailabilityUpdateInput;
    where: AvailabilityWhereUniqueInput;
  }) => AvailabilityPromise;
  updateManyAvailabilities: (args: {
    data: AvailabilityUpdateManyMutationInput;
    where?: AvailabilityWhereInput;
  }) => BatchPayloadPromise;
  upsertAvailability: (args: {
    where: AvailabilityWhereUniqueInput;
    create: AvailabilityCreateInput;
    update: AvailabilityUpdateInput;
  }) => AvailabilityPromise;
  deleteAvailability: (
    where: AvailabilityWhereUniqueInput
  ) => AvailabilityPromise;
  deleteManyAvailabilities: (
    where?: AvailabilityWhereInput
  ) => BatchPayloadPromise;
  createCareType: (data: CareTypeCreateInput) => CareTypePromise;
  updateCareType: (args: {
    data: CareTypeUpdateInput;
    where: CareTypeWhereUniqueInput;
  }) => CareTypePromise;
  updateManyCareTypes: (args: {
    data: CareTypeUpdateManyMutationInput;
    where?: CareTypeWhereInput;
  }) => BatchPayloadPromise;
  upsertCareType: (args: {
    where: CareTypeWhereUniqueInput;
    create: CareTypeCreateInput;
    update: CareTypeUpdateInput;
  }) => CareTypePromise;
  deleteCareType: (where: CareTypeWhereUniqueInput) => CareTypePromise;
  deleteManyCareTypes: (where?: CareTypeWhereInput) => BatchPayloadPromise;
  createUnavailability: (
    data: UnavailabilityCreateInput
  ) => UnavailabilityPromise;
  updateUnavailability: (args: {
    data: UnavailabilityUpdateInput;
    where: UnavailabilityWhereUniqueInput;
  }) => UnavailabilityPromise;
  updateManyUnavailabilities: (args: {
    data: UnavailabilityUpdateManyMutationInput;
    where?: UnavailabilityWhereInput;
  }) => BatchPayloadPromise;
  upsertUnavailability: (args: {
    where: UnavailabilityWhereUniqueInput;
    create: UnavailabilityCreateInput;
    update: UnavailabilityUpdateInput;
  }) => UnavailabilityPromise;
  deleteUnavailability: (
    where: UnavailabilityWhereUniqueInput
  ) => UnavailabilityPromise;
  deleteManyUnavailabilities: (
    where?: UnavailabilityWhereInput
  ) => BatchPayloadPromise;

  /**
   * Subscriptions
   */

  $subscribe: Subscription;
}

export interface Subscription {
  availability: (
    where?: AvailabilitySubscriptionWhereInput
  ) => AvailabilitySubscriptionPayloadSubscription;
  careType: (
    where?: CareTypeSubscriptionWhereInput
  ) => CareTypeSubscriptionPayloadSubscription;
  unavailability: (
    where?: UnavailabilitySubscriptionWhereInput
  ) => UnavailabilitySubscriptionPayloadSubscription;
}

export interface ClientConstructor<T> {
  new (options?: BaseClientOptions): T;
}

/**
 * Types
 */

export type AvailabilityOrderByInput =
  | "id_ASC"
  | "id_DESC"
  | "day_number_ASC"
  | "day_number_DESC"
  | "hour_start_ASC"
  | "hour_start_DESC"
  | "id_user_ASC"
  | "id_user_DESC"
  | "id_office_ASC"
  | "id_office_DESC";

export type CareTypeOrderByInput =
  | "id_ASC"
  | "id_DESC"
  | "label_ASC"
  | "label_DESC"
  | "description_ASC"
  | "description_DESC"
  | "color_schedule_ASC"
  | "color_schedule_DESC";

export type UnavailabilityOrderByInput =
  | "id_ASC"
  | "id_DESC"
  | "start_ASC"
  | "start_DESC"
  | "stop_ASC"
  | "stop_DESC"
  | "created_at_ASC"
  | "created_at_DESC"
  | "id_user_ASC"
  | "id_user_DESC"
  | "id_office_ASC"
  | "id_office_DESC";

export type MutationType = "CREATED" | "UPDATED" | "DELETED";

export type AvailabilityWhereUniqueInput = AtLeastOne<{
  id: Maybe<ID_Input>;
}>;

export interface AvailabilityWhereInput {
  id?: Maybe<ID_Input>;
  id_not?: Maybe<ID_Input>;
  id_in?: Maybe<ID_Input[] | ID_Input>;
  id_not_in?: Maybe<ID_Input[] | ID_Input>;
  id_lt?: Maybe<ID_Input>;
  id_lte?: Maybe<ID_Input>;
  id_gt?: Maybe<ID_Input>;
  id_gte?: Maybe<ID_Input>;
  id_contains?: Maybe<ID_Input>;
  id_not_contains?: Maybe<ID_Input>;
  id_starts_with?: Maybe<ID_Input>;
  id_not_starts_with?: Maybe<ID_Input>;
  id_ends_with?: Maybe<ID_Input>;
  id_not_ends_with?: Maybe<ID_Input>;
  day_number?: Maybe<Int>;
  day_number_not?: Maybe<Int>;
  day_number_in?: Maybe<Int[] | Int>;
  day_number_not_in?: Maybe<Int[] | Int>;
  day_number_lt?: Maybe<Int>;
  day_number_lte?: Maybe<Int>;
  day_number_gt?: Maybe<Int>;
  day_number_gte?: Maybe<Int>;
  hour_start?: Maybe<String>;
  hour_start_not?: Maybe<String>;
  hour_start_in?: Maybe<String[] | String>;
  hour_start_not_in?: Maybe<String[] | String>;
  hour_start_lt?: Maybe<String>;
  hour_start_lte?: Maybe<String>;
  hour_start_gt?: Maybe<String>;
  hour_start_gte?: Maybe<String>;
  hour_start_contains?: Maybe<String>;
  hour_start_not_contains?: Maybe<String>;
  hour_start_starts_with?: Maybe<String>;
  hour_start_not_starts_with?: Maybe<String>;
  hour_start_ends_with?: Maybe<String>;
  hour_start_not_ends_with?: Maybe<String>;
  id_user?: Maybe<Int>;
  id_user_not?: Maybe<Int>;
  id_user_in?: Maybe<Int[] | Int>;
  id_user_not_in?: Maybe<Int[] | Int>;
  id_user_lt?: Maybe<Int>;
  id_user_lte?: Maybe<Int>;
  id_user_gt?: Maybe<Int>;
  id_user_gte?: Maybe<Int>;
  id_office?: Maybe<Int>;
  id_office_not?: Maybe<Int>;
  id_office_in?: Maybe<Int[] | Int>;
  id_office_not_in?: Maybe<Int[] | Int>;
  id_office_lt?: Maybe<Int>;
  id_office_lte?: Maybe<Int>;
  id_office_gt?: Maybe<Int>;
  id_office_gte?: Maybe<Int>;
  AND?: Maybe<AvailabilityWhereInput[] | AvailabilityWhereInput>;
  OR?: Maybe<AvailabilityWhereInput[] | AvailabilityWhereInput>;
  NOT?: Maybe<AvailabilityWhereInput[] | AvailabilityWhereInput>;
}

export type CareTypeWhereUniqueInput = AtLeastOne<{
  id: Maybe<ID_Input>;
}>;

export interface CareTypeWhereInput {
  id?: Maybe<ID_Input>;
  id_not?: Maybe<ID_Input>;
  id_in?: Maybe<ID_Input[] | ID_Input>;
  id_not_in?: Maybe<ID_Input[] | ID_Input>;
  id_lt?: Maybe<ID_Input>;
  id_lte?: Maybe<ID_Input>;
  id_gt?: Maybe<ID_Input>;
  id_gte?: Maybe<ID_Input>;
  id_contains?: Maybe<ID_Input>;
  id_not_contains?: Maybe<ID_Input>;
  id_starts_with?: Maybe<ID_Input>;
  id_not_starts_with?: Maybe<ID_Input>;
  id_ends_with?: Maybe<ID_Input>;
  id_not_ends_with?: Maybe<ID_Input>;
  label?: Maybe<String>;
  label_not?: Maybe<String>;
  label_in?: Maybe<String[] | String>;
  label_not_in?: Maybe<String[] | String>;
  label_lt?: Maybe<String>;
  label_lte?: Maybe<String>;
  label_gt?: Maybe<String>;
  label_gte?: Maybe<String>;
  label_contains?: Maybe<String>;
  label_not_contains?: Maybe<String>;
  label_starts_with?: Maybe<String>;
  label_not_starts_with?: Maybe<String>;
  label_ends_with?: Maybe<String>;
  label_not_ends_with?: Maybe<String>;
  description?: Maybe<String>;
  description_not?: Maybe<String>;
  description_in?: Maybe<String[] | String>;
  description_not_in?: Maybe<String[] | String>;
  description_lt?: Maybe<String>;
  description_lte?: Maybe<String>;
  description_gt?: Maybe<String>;
  description_gte?: Maybe<String>;
  description_contains?: Maybe<String>;
  description_not_contains?: Maybe<String>;
  description_starts_with?: Maybe<String>;
  description_not_starts_with?: Maybe<String>;
  description_ends_with?: Maybe<String>;
  description_not_ends_with?: Maybe<String>;
  color_schedule?: Maybe<String>;
  color_schedule_not?: Maybe<String>;
  color_schedule_in?: Maybe<String[] | String>;
  color_schedule_not_in?: Maybe<String[] | String>;
  color_schedule_lt?: Maybe<String>;
  color_schedule_lte?: Maybe<String>;
  color_schedule_gt?: Maybe<String>;
  color_schedule_gte?: Maybe<String>;
  color_schedule_contains?: Maybe<String>;
  color_schedule_not_contains?: Maybe<String>;
  color_schedule_starts_with?: Maybe<String>;
  color_schedule_not_starts_with?: Maybe<String>;
  color_schedule_ends_with?: Maybe<String>;
  color_schedule_not_ends_with?: Maybe<String>;
  AND?: Maybe<CareTypeWhereInput[] | CareTypeWhereInput>;
  OR?: Maybe<CareTypeWhereInput[] | CareTypeWhereInput>;
  NOT?: Maybe<CareTypeWhereInput[] | CareTypeWhereInput>;
}

export type UnavailabilityWhereUniqueInput = AtLeastOne<{
  id: Maybe<ID_Input>;
}>;

export interface UnavailabilityWhereInput {
  id?: Maybe<ID_Input>;
  id_not?: Maybe<ID_Input>;
  id_in?: Maybe<ID_Input[] | ID_Input>;
  id_not_in?: Maybe<ID_Input[] | ID_Input>;
  id_lt?: Maybe<ID_Input>;
  id_lte?: Maybe<ID_Input>;
  id_gt?: Maybe<ID_Input>;
  id_gte?: Maybe<ID_Input>;
  id_contains?: Maybe<ID_Input>;
  id_not_contains?: Maybe<ID_Input>;
  id_starts_with?: Maybe<ID_Input>;
  id_not_starts_with?: Maybe<ID_Input>;
  id_ends_with?: Maybe<ID_Input>;
  id_not_ends_with?: Maybe<ID_Input>;
  start?: Maybe<DateTimeInput>;
  start_not?: Maybe<DateTimeInput>;
  start_in?: Maybe<DateTimeInput[] | DateTimeInput>;
  start_not_in?: Maybe<DateTimeInput[] | DateTimeInput>;
  start_lt?: Maybe<DateTimeInput>;
  start_lte?: Maybe<DateTimeInput>;
  start_gt?: Maybe<DateTimeInput>;
  start_gte?: Maybe<DateTimeInput>;
  stop?: Maybe<DateTimeInput>;
  stop_not?: Maybe<DateTimeInput>;
  stop_in?: Maybe<DateTimeInput[] | DateTimeInput>;
  stop_not_in?: Maybe<DateTimeInput[] | DateTimeInput>;
  stop_lt?: Maybe<DateTimeInput>;
  stop_lte?: Maybe<DateTimeInput>;
  stop_gt?: Maybe<DateTimeInput>;
  stop_gte?: Maybe<DateTimeInput>;
  created_at?: Maybe<DateTimeInput>;
  created_at_not?: Maybe<DateTimeInput>;
  created_at_in?: Maybe<DateTimeInput[] | DateTimeInput>;
  created_at_not_in?: Maybe<DateTimeInput[] | DateTimeInput>;
  created_at_lt?: Maybe<DateTimeInput>;
  created_at_lte?: Maybe<DateTimeInput>;
  created_at_gt?: Maybe<DateTimeInput>;
  created_at_gte?: Maybe<DateTimeInput>;
  id_user?: Maybe<Int>;
  id_user_not?: Maybe<Int>;
  id_user_in?: Maybe<Int[] | Int>;
  id_user_not_in?: Maybe<Int[] | Int>;
  id_user_lt?: Maybe<Int>;
  id_user_lte?: Maybe<Int>;
  id_user_gt?: Maybe<Int>;
  id_user_gte?: Maybe<Int>;
  id_office?: Maybe<Int>;
  id_office_not?: Maybe<Int>;
  id_office_in?: Maybe<Int[] | Int>;
  id_office_not_in?: Maybe<Int[] | Int>;
  id_office_lt?: Maybe<Int>;
  id_office_lte?: Maybe<Int>;
  id_office_gt?: Maybe<Int>;
  id_office_gte?: Maybe<Int>;
  AND?: Maybe<UnavailabilityWhereInput[] | UnavailabilityWhereInput>;
  OR?: Maybe<UnavailabilityWhereInput[] | UnavailabilityWhereInput>;
  NOT?: Maybe<UnavailabilityWhereInput[] | UnavailabilityWhereInput>;
}

export interface AvailabilityCreateInput {
  id?: Maybe<ID_Input>;
  day_number: Int;
  hour_start: String;
  id_user: Int;
  id_office: Int;
}

export interface AvailabilityUpdateInput {
  day_number?: Maybe<Int>;
  hour_start?: Maybe<String>;
  id_user?: Maybe<Int>;
  id_office?: Maybe<Int>;
}

export interface AvailabilityUpdateManyMutationInput {
  day_number?: Maybe<Int>;
  hour_start?: Maybe<String>;
  id_user?: Maybe<Int>;
  id_office?: Maybe<Int>;
}

export interface CareTypeCreateInput {
  id?: Maybe<ID_Input>;
  label: String;
  description?: Maybe<String>;
  color_schedule?: Maybe<String>;
}

export interface CareTypeUpdateInput {
  label?: Maybe<String>;
  description?: Maybe<String>;
  color_schedule?: Maybe<String>;
}

export interface CareTypeUpdateManyMutationInput {
  label?: Maybe<String>;
  description?: Maybe<String>;
  color_schedule?: Maybe<String>;
}

export interface UnavailabilityCreateInput {
  id?: Maybe<ID_Input>;
  start: DateTimeInput;
  stop: DateTimeInput;
  created_at: DateTimeInput;
  id_user: Int;
  id_office: Int;
}

export interface UnavailabilityUpdateInput {
  start?: Maybe<DateTimeInput>;
  stop?: Maybe<DateTimeInput>;
  created_at?: Maybe<DateTimeInput>;
  id_user?: Maybe<Int>;
  id_office?: Maybe<Int>;
}

export interface UnavailabilityUpdateManyMutationInput {
  start?: Maybe<DateTimeInput>;
  stop?: Maybe<DateTimeInput>;
  created_at?: Maybe<DateTimeInput>;
  id_user?: Maybe<Int>;
  id_office?: Maybe<Int>;
}

export interface AvailabilitySubscriptionWhereInput {
  mutation_in?: Maybe<MutationType[] | MutationType>;
  updatedFields_contains?: Maybe<String>;
  updatedFields_contains_every?: Maybe<String[] | String>;
  updatedFields_contains_some?: Maybe<String[] | String>;
  node?: Maybe<AvailabilityWhereInput>;
  AND?: Maybe<
    AvailabilitySubscriptionWhereInput[] | AvailabilitySubscriptionWhereInput
  >;
  OR?: Maybe<
    AvailabilitySubscriptionWhereInput[] | AvailabilitySubscriptionWhereInput
  >;
  NOT?: Maybe<
    AvailabilitySubscriptionWhereInput[] | AvailabilitySubscriptionWhereInput
  >;
}

export interface CareTypeSubscriptionWhereInput {
  mutation_in?: Maybe<MutationType[] | MutationType>;
  updatedFields_contains?: Maybe<String>;
  updatedFields_contains_every?: Maybe<String[] | String>;
  updatedFields_contains_some?: Maybe<String[] | String>;
  node?: Maybe<CareTypeWhereInput>;
  AND?: Maybe<
    CareTypeSubscriptionWhereInput[] | CareTypeSubscriptionWhereInput
  >;
  OR?: Maybe<CareTypeSubscriptionWhereInput[] | CareTypeSubscriptionWhereInput>;
  NOT?: Maybe<
    CareTypeSubscriptionWhereInput[] | CareTypeSubscriptionWhereInput
  >;
}

export interface UnavailabilitySubscriptionWhereInput {
  mutation_in?: Maybe<MutationType[] | MutationType>;
  updatedFields_contains?: Maybe<String>;
  updatedFields_contains_every?: Maybe<String[] | String>;
  updatedFields_contains_some?: Maybe<String[] | String>;
  node?: Maybe<UnavailabilityWhereInput>;
  AND?: Maybe<
    | UnavailabilitySubscriptionWhereInput[]
    | UnavailabilitySubscriptionWhereInput
  >;
  OR?: Maybe<
    | UnavailabilitySubscriptionWhereInput[]
    | UnavailabilitySubscriptionWhereInput
  >;
  NOT?: Maybe<
    | UnavailabilitySubscriptionWhereInput[]
    | UnavailabilitySubscriptionWhereInput
  >;
}

export interface NodeNode {
  id: ID_Output;
}

export interface Availability {
  id: ID_Output;
  day_number: Int;
  hour_start: String;
  id_user: Int;
  id_office: Int;
}

export interface AvailabilityPromise
  extends Promise<Availability>,
    Fragmentable {
  id: () => Promise<ID_Output>;
  day_number: () => Promise<Int>;
  hour_start: () => Promise<String>;
  id_user: () => Promise<Int>;
  id_office: () => Promise<Int>;
}

export interface AvailabilitySubscription
  extends Promise<AsyncIterator<Availability>>,
    Fragmentable {
  id: () => Promise<AsyncIterator<ID_Output>>;
  day_number: () => Promise<AsyncIterator<Int>>;
  hour_start: () => Promise<AsyncIterator<String>>;
  id_user: () => Promise<AsyncIterator<Int>>;
  id_office: () => Promise<AsyncIterator<Int>>;
}

export interface AvailabilityNullablePromise
  extends Promise<Availability | null>,
    Fragmentable {
  id: () => Promise<ID_Output>;
  day_number: () => Promise<Int>;
  hour_start: () => Promise<String>;
  id_user: () => Promise<Int>;
  id_office: () => Promise<Int>;
}

export interface AvailabilityConnection {
  pageInfo: PageInfo;
  edges: AvailabilityEdge[];
}

export interface AvailabilityConnectionPromise
  extends Promise<AvailabilityConnection>,
    Fragmentable {
  pageInfo: <T = PageInfoPromise>() => T;
  edges: <T = FragmentableArray<AvailabilityEdge>>() => T;
  aggregate: <T = AggregateAvailabilityPromise>() => T;
}

export interface AvailabilityConnectionSubscription
  extends Promise<AsyncIterator<AvailabilityConnection>>,
    Fragmentable {
  pageInfo: <T = PageInfoSubscription>() => T;
  edges: <T = Promise<AsyncIterator<AvailabilityEdgeSubscription>>>() => T;
  aggregate: <T = AggregateAvailabilitySubscription>() => T;
}

export interface PageInfo {
  hasNextPage: Boolean;
  hasPreviousPage: Boolean;
  startCursor?: String;
  endCursor?: String;
}

export interface PageInfoPromise extends Promise<PageInfo>, Fragmentable {
  hasNextPage: () => Promise<Boolean>;
  hasPreviousPage: () => Promise<Boolean>;
  startCursor: () => Promise<String>;
  endCursor: () => Promise<String>;
}

export interface PageInfoSubscription
  extends Promise<AsyncIterator<PageInfo>>,
    Fragmentable {
  hasNextPage: () => Promise<AsyncIterator<Boolean>>;
  hasPreviousPage: () => Promise<AsyncIterator<Boolean>>;
  startCursor: () => Promise<AsyncIterator<String>>;
  endCursor: () => Promise<AsyncIterator<String>>;
}

export interface AvailabilityEdge {
  node: Availability;
  cursor: String;
}

export interface AvailabilityEdgePromise
  extends Promise<AvailabilityEdge>,
    Fragmentable {
  node: <T = AvailabilityPromise>() => T;
  cursor: () => Promise<String>;
}

export interface AvailabilityEdgeSubscription
  extends Promise<AsyncIterator<AvailabilityEdge>>,
    Fragmentable {
  node: <T = AvailabilitySubscription>() => T;
  cursor: () => Promise<AsyncIterator<String>>;
}

export interface AggregateAvailability {
  count: Int;
}

export interface AggregateAvailabilityPromise
  extends Promise<AggregateAvailability>,
    Fragmentable {
  count: () => Promise<Int>;
}

export interface AggregateAvailabilitySubscription
  extends Promise<AsyncIterator<AggregateAvailability>>,
    Fragmentable {
  count: () => Promise<AsyncIterator<Int>>;
}

export interface CareType {
  id: ID_Output;
  label: String;
  description?: String;
  color_schedule?: String;
}

export interface CareTypePromise extends Promise<CareType>, Fragmentable {
  id: () => Promise<ID_Output>;
  label: () => Promise<String>;
  description: () => Promise<String>;
  color_schedule: () => Promise<String>;
}

export interface CareTypeSubscription
  extends Promise<AsyncIterator<CareType>>,
    Fragmentable {
  id: () => Promise<AsyncIterator<ID_Output>>;
  label: () => Promise<AsyncIterator<String>>;
  description: () => Promise<AsyncIterator<String>>;
  color_schedule: () => Promise<AsyncIterator<String>>;
}

export interface CareTypeNullablePromise
  extends Promise<CareType | null>,
    Fragmentable {
  id: () => Promise<ID_Output>;
  label: () => Promise<String>;
  description: () => Promise<String>;
  color_schedule: () => Promise<String>;
}

export interface CareTypeConnection {
  pageInfo: PageInfo;
  edges: CareTypeEdge[];
}

export interface CareTypeConnectionPromise
  extends Promise<CareTypeConnection>,
    Fragmentable {
  pageInfo: <T = PageInfoPromise>() => T;
  edges: <T = FragmentableArray<CareTypeEdge>>() => T;
  aggregate: <T = AggregateCareTypePromise>() => T;
}

export interface CareTypeConnectionSubscription
  extends Promise<AsyncIterator<CareTypeConnection>>,
    Fragmentable {
  pageInfo: <T = PageInfoSubscription>() => T;
  edges: <T = Promise<AsyncIterator<CareTypeEdgeSubscription>>>() => T;
  aggregate: <T = AggregateCareTypeSubscription>() => T;
}

export interface CareTypeEdge {
  node: CareType;
  cursor: String;
}

export interface CareTypeEdgePromise
  extends Promise<CareTypeEdge>,
    Fragmentable {
  node: <T = CareTypePromise>() => T;
  cursor: () => Promise<String>;
}

export interface CareTypeEdgeSubscription
  extends Promise<AsyncIterator<CareTypeEdge>>,
    Fragmentable {
  node: <T = CareTypeSubscription>() => T;
  cursor: () => Promise<AsyncIterator<String>>;
}

export interface AggregateCareType {
  count: Int;
}

export interface AggregateCareTypePromise
  extends Promise<AggregateCareType>,
    Fragmentable {
  count: () => Promise<Int>;
}

export interface AggregateCareTypeSubscription
  extends Promise<AsyncIterator<AggregateCareType>>,
    Fragmentable {
  count: () => Promise<AsyncIterator<Int>>;
}

export interface Unavailability {
  id: ID_Output;
  start: DateTimeOutput;
  stop: DateTimeOutput;
  created_at: DateTimeOutput;
  id_user: Int;
  id_office: Int;
}

export interface UnavailabilityPromise
  extends Promise<Unavailability>,
    Fragmentable {
  id: () => Promise<ID_Output>;
  start: () => Promise<DateTimeOutput>;
  stop: () => Promise<DateTimeOutput>;
  created_at: () => Promise<DateTimeOutput>;
  id_user: () => Promise<Int>;
  id_office: () => Promise<Int>;
}

export interface UnavailabilitySubscription
  extends Promise<AsyncIterator<Unavailability>>,
    Fragmentable {
  id: () => Promise<AsyncIterator<ID_Output>>;
  start: () => Promise<AsyncIterator<DateTimeOutput>>;
  stop: () => Promise<AsyncIterator<DateTimeOutput>>;
  created_at: () => Promise<AsyncIterator<DateTimeOutput>>;
  id_user: () => Promise<AsyncIterator<Int>>;
  id_office: () => Promise<AsyncIterator<Int>>;
}

export interface UnavailabilityNullablePromise
  extends Promise<Unavailability | null>,
    Fragmentable {
  id: () => Promise<ID_Output>;
  start: () => Promise<DateTimeOutput>;
  stop: () => Promise<DateTimeOutput>;
  created_at: () => Promise<DateTimeOutput>;
  id_user: () => Promise<Int>;
  id_office: () => Promise<Int>;
}

export interface UnavailabilityConnection {
  pageInfo: PageInfo;
  edges: UnavailabilityEdge[];
}

export interface UnavailabilityConnectionPromise
  extends Promise<UnavailabilityConnection>,
    Fragmentable {
  pageInfo: <T = PageInfoPromise>() => T;
  edges: <T = FragmentableArray<UnavailabilityEdge>>() => T;
  aggregate: <T = AggregateUnavailabilityPromise>() => T;
}

export interface UnavailabilityConnectionSubscription
  extends Promise<AsyncIterator<UnavailabilityConnection>>,
    Fragmentable {
  pageInfo: <T = PageInfoSubscription>() => T;
  edges: <T = Promise<AsyncIterator<UnavailabilityEdgeSubscription>>>() => T;
  aggregate: <T = AggregateUnavailabilitySubscription>() => T;
}

export interface UnavailabilityEdge {
  node: Unavailability;
  cursor: String;
}

export interface UnavailabilityEdgePromise
  extends Promise<UnavailabilityEdge>,
    Fragmentable {
  node: <T = UnavailabilityPromise>() => T;
  cursor: () => Promise<String>;
}

export interface UnavailabilityEdgeSubscription
  extends Promise<AsyncIterator<UnavailabilityEdge>>,
    Fragmentable {
  node: <T = UnavailabilitySubscription>() => T;
  cursor: () => Promise<AsyncIterator<String>>;
}

export interface AggregateUnavailability {
  count: Int;
}

export interface AggregateUnavailabilityPromise
  extends Promise<AggregateUnavailability>,
    Fragmentable {
  count: () => Promise<Int>;
}

export interface AggregateUnavailabilitySubscription
  extends Promise<AsyncIterator<AggregateUnavailability>>,
    Fragmentable {
  count: () => Promise<AsyncIterator<Int>>;
}

export interface BatchPayload {
  count: Long;
}

export interface BatchPayloadPromise
  extends Promise<BatchPayload>,
    Fragmentable {
  count: () => Promise<Long>;
}

export interface BatchPayloadSubscription
  extends Promise<AsyncIterator<BatchPayload>>,
    Fragmentable {
  count: () => Promise<AsyncIterator<Long>>;
}

export interface AvailabilitySubscriptionPayload {
  mutation: MutationType;
  node: Availability;
  updatedFields: String[];
  previousValues: AvailabilityPreviousValues;
}

export interface AvailabilitySubscriptionPayloadPromise
  extends Promise<AvailabilitySubscriptionPayload>,
    Fragmentable {
  mutation: () => Promise<MutationType>;
  node: <T = AvailabilityPromise>() => T;
  updatedFields: () => Promise<String[]>;
  previousValues: <T = AvailabilityPreviousValuesPromise>() => T;
}

export interface AvailabilitySubscriptionPayloadSubscription
  extends Promise<AsyncIterator<AvailabilitySubscriptionPayload>>,
    Fragmentable {
  mutation: () => Promise<AsyncIterator<MutationType>>;
  node: <T = AvailabilitySubscription>() => T;
  updatedFields: () => Promise<AsyncIterator<String[]>>;
  previousValues: <T = AvailabilityPreviousValuesSubscription>() => T;
}

export interface AvailabilityPreviousValues {
  id: ID_Output;
  day_number: Int;
  hour_start: String;
  id_user: Int;
  id_office: Int;
}

export interface AvailabilityPreviousValuesPromise
  extends Promise<AvailabilityPreviousValues>,
    Fragmentable {
  id: () => Promise<ID_Output>;
  day_number: () => Promise<Int>;
  hour_start: () => Promise<String>;
  id_user: () => Promise<Int>;
  id_office: () => Promise<Int>;
}

export interface AvailabilityPreviousValuesSubscription
  extends Promise<AsyncIterator<AvailabilityPreviousValues>>,
    Fragmentable {
  id: () => Promise<AsyncIterator<ID_Output>>;
  day_number: () => Promise<AsyncIterator<Int>>;
  hour_start: () => Promise<AsyncIterator<String>>;
  id_user: () => Promise<AsyncIterator<Int>>;
  id_office: () => Promise<AsyncIterator<Int>>;
}

export interface CareTypeSubscriptionPayload {
  mutation: MutationType;
  node: CareType;
  updatedFields: String[];
  previousValues: CareTypePreviousValues;
}

export interface CareTypeSubscriptionPayloadPromise
  extends Promise<CareTypeSubscriptionPayload>,
    Fragmentable {
  mutation: () => Promise<MutationType>;
  node: <T = CareTypePromise>() => T;
  updatedFields: () => Promise<String[]>;
  previousValues: <T = CareTypePreviousValuesPromise>() => T;
}

export interface CareTypeSubscriptionPayloadSubscription
  extends Promise<AsyncIterator<CareTypeSubscriptionPayload>>,
    Fragmentable {
  mutation: () => Promise<AsyncIterator<MutationType>>;
  node: <T = CareTypeSubscription>() => T;
  updatedFields: () => Promise<AsyncIterator<String[]>>;
  previousValues: <T = CareTypePreviousValuesSubscription>() => T;
}

export interface CareTypePreviousValues {
  id: ID_Output;
  label: String;
  description?: String;
  color_schedule?: String;
}

export interface CareTypePreviousValuesPromise
  extends Promise<CareTypePreviousValues>,
    Fragmentable {
  id: () => Promise<ID_Output>;
  label: () => Promise<String>;
  description: () => Promise<String>;
  color_schedule: () => Promise<String>;
}

export interface CareTypePreviousValuesSubscription
  extends Promise<AsyncIterator<CareTypePreviousValues>>,
    Fragmentable {
  id: () => Promise<AsyncIterator<ID_Output>>;
  label: () => Promise<AsyncIterator<String>>;
  description: () => Promise<AsyncIterator<String>>;
  color_schedule: () => Promise<AsyncIterator<String>>;
}

export interface UnavailabilitySubscriptionPayload {
  mutation: MutationType;
  node: Unavailability;
  updatedFields: String[];
  previousValues: UnavailabilityPreviousValues;
}

export interface UnavailabilitySubscriptionPayloadPromise
  extends Promise<UnavailabilitySubscriptionPayload>,
    Fragmentable {
  mutation: () => Promise<MutationType>;
  node: <T = UnavailabilityPromise>() => T;
  updatedFields: () => Promise<String[]>;
  previousValues: <T = UnavailabilityPreviousValuesPromise>() => T;
}

export interface UnavailabilitySubscriptionPayloadSubscription
  extends Promise<AsyncIterator<UnavailabilitySubscriptionPayload>>,
    Fragmentable {
  mutation: () => Promise<AsyncIterator<MutationType>>;
  node: <T = UnavailabilitySubscription>() => T;
  updatedFields: () => Promise<AsyncIterator<String[]>>;
  previousValues: <T = UnavailabilityPreviousValuesSubscription>() => T;
}

export interface UnavailabilityPreviousValues {
  id: ID_Output;
  start: DateTimeOutput;
  stop: DateTimeOutput;
  created_at: DateTimeOutput;
  id_user: Int;
  id_office: Int;
}

export interface UnavailabilityPreviousValuesPromise
  extends Promise<UnavailabilityPreviousValues>,
    Fragmentable {
  id: () => Promise<ID_Output>;
  start: () => Promise<DateTimeOutput>;
  stop: () => Promise<DateTimeOutput>;
  created_at: () => Promise<DateTimeOutput>;
  id_user: () => Promise<Int>;
  id_office: () => Promise<Int>;
}

export interface UnavailabilityPreviousValuesSubscription
  extends Promise<AsyncIterator<UnavailabilityPreviousValues>>,
    Fragmentable {
  id: () => Promise<AsyncIterator<ID_Output>>;
  start: () => Promise<AsyncIterator<DateTimeOutput>>;
  stop: () => Promise<AsyncIterator<DateTimeOutput>>;
  created_at: () => Promise<AsyncIterator<DateTimeOutput>>;
  id_user: () => Promise<AsyncIterator<Int>>;
  id_office: () => Promise<AsyncIterator<Int>>;
}

/*
The `ID` scalar type represents a unique identifier, often used to refetch an object or as key for a cache. The ID type appears in a JSON response as a String; however, it is not intended to be human-readable. When expected as an input type, any string (such as `"4"`) or integer (such as `4`) input value will be accepted as an ID.
*/
export type ID_Input = string | number;
export type ID_Output = string;

/*
The `Int` scalar type represents non-fractional signed whole numeric values. Int can represent values between -(2^31) and 2^31 - 1.
*/
export type Int = number;

/*
The `String` scalar type represents textual data, represented as UTF-8 character sequences. The String type is most often used by GraphQL to represent free-form human-readable text.
*/
export type String = string;

/*
The `Boolean` scalar type represents `true` or `false`.
*/
export type Boolean = boolean;

/*
DateTime scalar input type, allowing Date
*/
export type DateTimeInput = Date | string;

/*
DateTime scalar output type, which is always a string
*/
export type DateTimeOutput = string;

export type Long = string;

/**
 * Model Metadata
 */

export const models: Model[] = [
  {
    name: "Availability",
    embedded: false
  },
  {
    name: "Unavailability",
    embedded: false
  },
  {
    name: "CareType",
    embedded: false
  }
];

/**
 * Type Defs
 */

export const prisma: Prisma;
